/* @(#)help.c 1.17 Software Membership 11/16/95 */
/*
	SM/Editor - Version 2

    ---------
    Copyright (C) Si-Won Cho
            Dept. of Electrical Engineering
            Dongguk University
            Seoul, KOREA
            chosw@dgu4680.dongguk.ac.kr

            SAMSUNG Electronics
            Software Membership

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    ---------
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#ifdef hpux
#include <strings.h>
#endif
#include <sys/types.h>
#include <sys/stat.h>
#include <X11/Intrinsic.h>
#include <Xm/Text.h>
#include <Xm/Form.h>
#include <Xm/PushB.h>
#include <Xm/SeparatoG.h>

Widget	help_text, seperator_w, sub_form, ok_button;

#ifdef _NO_PROTO
void	closeHelpDialog_cb();
#else
void	closeHelpDialog_cb(Widget, XtPointer, XtPointer);
#endif
void	loadHelpText();

#ifdef _NO_PROTO
Widget CreateHelpDialog(parent, name)
Widget parent;
char *name;
#else
Widget CreateHelpDialog(Widget parent, char *name)
#endif
{
	Widget	form;
	Arg args[14];

	form = XmCreateFormDialog(parent, name, args, 0);

	sub_form = XtVaCreateWidget("Form",
		xmFormWidgetClass, form,
		XmNfractionBase,	5,
                XmNleftAttachment,      XmATTACH_FORM,
                XmNleftOffset,		1,
                XmNrightAttachment,     XmATTACH_FORM,
                XmNrightOffset,		1,
                XmNbottomAttachment,	XmATTACH_FORM,
                XmNbottomOffset,		1,
                NULL);

	ok_button = XtVaCreateManagedWidget("helpOk",
		xmPushButtonWidgetClass, sub_form,
		XmNshowAsDefault,	True,
		XmNtopAttachment,	XmATTACH_FORM,
		XmNtopOffset,		4,
		XmNleftAttachment,	XmATTACH_POSITION,
		XmNleftPosition,	2,
		XmNrightAttachment,	XmATTACH_POSITION,
		XmNrightPosition,	3,
                XmNbottomAttachment,	XmATTACH_FORM,
		XmNbottomOffset,	4,
		NULL);

	XtAddCallback(ok_button,
	        XmNactivateCallback, closeHelpDialog_cb, (XtPointer)form);

	seperator_w = XtVaCreateManagedWidget("Separator",
                xmSeparatorGadgetClass, form,
                XmNleftAttachment,      XmATTACH_FORM,
                XmNrightAttachment,     XmATTACH_FORM,
                XmNbottomAttachment,	XmATTACH_WIDGET,
                XmNbottomWidget,	sub_form,
                XmNbottomOffset,	2,
                NULL);

	XtSetArg(args[0], XmNeditMode,		XmMULTI_LINE_EDIT);
	XtSetArg(args[1], XmNrows,		12);
	XtSetArg(args[2], XmNcolumns,		56);
	XtSetArg(args[3], XmNeditMode,		False);
	XtSetArg(args[4], XmNeditable,		False);
	XtSetArg(args[5], XmNtopAttachment,     XmATTACH_FORM);
        XtSetArg(args[6], XmNtopOffset,		5);
	XtSetArg(args[7], XmNleftAttachment,    XmATTACH_FORM);
        XtSetArg(args[8], XmNleftOffset,	5);
	XtSetArg(args[9], XmNrightAttachment,  XmATTACH_FORM);
        XtSetArg(args[10], XmNrightOffset,	5);
	XtSetArg(args[11], XmNbottomAttachment, XmATTACH_WIDGET);
        XtSetArg(args[12], XmNbottomWidget,	seperator_w);
        XtSetArg(args[13], XmNbottomOffset,	2);

	help_text = XmCreateScrolledText(form, "helpText", args, 14);

	XtManageChild(help_text);
	XtManageChild(sub_form);

	return (form);
}

#ifdef _NO_PROTO
void closeHelpDialog_cb(w, client_data, call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;
#else
void closeHelpDialog_cb(Widget w, XtPointer client_data, XtPointer call_data)
#endif
{
	Widget dialog = (Widget)client_data;

	XtUnmanageChild(dialog);
}

void loadHelpText()
{
	char *str, buf[BUFSIZ];
	FILE *fp;
	struct stat statb;

	(void)sprintf(buf, "%s/smedit.help", getenv("SMEDIT_PATH"));
	if ((fp = fopen(buf, "r")) == NULL) {
	    (void)sprintf(buf, "/usr/lib/X11/smedit.help");
	    fp = fopen(buf, "r");
	}
	if (fp != NULL) {
	    (void)stat(buf, &statb);
	    str = XtMalloc((Cardinal)statb.st_size + 1);
	    if (fread(str, sizeof(char), (int)statb.st_size, fp) != statb.st_size)
	        (void)sprintf(buf, "\nWarning: did not read entire file!\n");
	    str[statb.st_size] = '\0';
	    fclose(fp);
	    XmTextSetString(help_text, str);
	    XtFree(str);
	}
	else {
	    str = XtMalloc((Cardinal)BUFSIZ);
	    (void)sprintf(str, "\n\t\tHelp file : smedit.help not found");
	    XmTextSetString(help_text, str);
	    XtFree(str);
	}
}




